com.amazon.redshift.plugin

## Class BrowserSamlCredentialsProvider

- java.lang.Object
- - com.amazon.redshift.plugin.SamlCredentialsProvider
  - - com.amazon.redshift.plugin.BrowserSamlCredentialsProvider

All Implemented Interfaces:
  IPlugin

    public class BrowserSamlCredentialsProvider
    extends SamlCredentialsProvider

Class to get SAML Assertion from a web service which is able to produce SAML assertion by requesting the specific URL.

### Field Summary

Fields
`static String` `KEY_IDP_RESPONSE_TIMEOUT` String containing "idp_response_timeout" as a parameter key.
`static String` `KEY_LISTEN_PORT` String containing "listen_port" as a parameter key.
`static String` `KEY_LOGIN_URL` String containing "login_url" as a parameter key.

### Fields inherited from class com.amazon.redshift.plugin.SamlCredentialsProvider

`KEY_IDP_HOST, m_autoCreate, m_dbGroups, m_dbGroupsFilter, m_dbUser, m_disableCache, m_duration, m_forceLowercase, m_groupFederation, m_idpHost, m_idpPort, m_log, m_password, m_preferredRole, m_region, m_sslInsecure, m_stsEndpoint, m_userName`

### Constructor Summary

Constructors
Constructor and Description
`BrowserSamlCredentialsProvider()`

### Method Summary

All Methods Instance Methods Concrete Methods
`void` `addParameter(String key, String value)` Overwritten method to grab the field parameters from JDBC connection string.
`String` `getPluginSpecificCacheKey()`
`protected String` `getSamlAssertion()` Overridden method to grab the SAML Response.

### Methods inherited from class com.amazon.redshift.plugin.SamlCredentialsProvider

`checkRequiredParameters, escapeHtmlEntity, getCacheKey, getCredentials, getFormAction, getHttpClient, getIdpToken, getInputTagsfromHTML, getSubType, getValueByKey, getValueByKeyWithoutQuotesAndValueInSingleQuote, isPassword, isText, refresh, setGroupFederation, setLogger`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### KEY_LOGIN_URL

    public static final String KEY_LOGIN_URL

String containing "login_url" as a parameter key.

See Also:
  Constant Field Values

#### KEY_IDP_RESPONSE_TIMEOUT

    public static final String KEY_IDP_RESPONSE_TIMEOUT

String containing "idp_response_timeout" as a parameter key.

See Also:
  Constant Field Values

#### KEY_LISTEN_PORT

    public static final String KEY_LISTEN_PORT

String containing "listen_port" as a parameter key.

See Also:
  Constant Field Values

### Constructor Detail

#### BrowserSamlCredentialsProvider

    public BrowserSamlCredentialsProvider()

### Method Detail

#### getSamlAssertion

    protected String getSamlAssertion()
                               throws IOException

Overridden method to grab the SAML Response. Used in base class to refresh temporary credentials.

Specified by:
  `getSamlAssertion` in class `SamlCredentialsProvider`
Returns:
  Base64 encoded SAML Response string
Throws:
  `IOException` - as part of common API. mean parameters are not set or has invalid values.

#### addParameter

    public void addParameter(String key,
                             String value)

Overwritten method to grab the field parameters from JDBC connection string. This method calls the base class' addParameter method and adds to it new specific parameters.

Specified by:
  `addParameter` in interface `IPlugin`
Overrides:
  `addParameter` in class `SamlCredentialsProvider`
Parameters:
  `key` - parameter key passed to JDBC
  `value` - parameter value associated with the given key

#### getPluginSpecificCacheKey

    public String getPluginSpecificCacheKey()

Specified by:
  `getPluginSpecificCacheKey` in interface `IPlugin`
Overrides:
  `getPluginSpecificCacheKey` in class `SamlCredentialsProvider`